/**********************************************/
/* _bnc_mpf.h:                                */
/* Copyright (C) 2003 Tomonori Kouya          */
/*                                            */
/* This library is free software; you can re- */
/* distribute it and/or modify it under the   */
/* terms of the GNU Lesser General Public     */
/* License as published by the Free Software  */
/* Foundation; either version 2.1 of the      */
/* License, or (at your option) any later     */
/* version.                                   */
/*                                            */
/* This library is distributed in the hope    */
/* that it will be useful, but WITHOUT ANY    */
/* WARRANTY; without even the implied         */
/* warranty of MERCHANTABILITY or FITNESS FOR */
/* A PARTICULAR PURPOSE.  See the GNU Lesser  */
/* General Public License for more details.   */
/**********************************************/
/* mpf.h */
/* Modified mpf2mpfr.h to mpf.h by Tomonori Kouya */

/* types */
#define _bnc_mpf_t mpf_t

/* functions which don't take as argument the rounding mode */
#define _bnc_mpf_ceil mpf_ceil
#define _bnc_mpf_clear mpf_clear
#define _bnc_mpf_cmp mpf_cmp
#define _bnc_mpf_cmp_si mpf_cmp_si
#define _bnc_mpf_cmp_ui mpf_cmp_ui
#define _bnc_mpf_eq mpf_eq
#define _bnc_mpf_floor mpf_floor
#define _bnc_mpf_get_d mpf_get_d1
#define _bnc_mpf_get_prec mpf_get_prec
#define _bnc_mpf_init mpf_init
#define _bnc_mpf_init2 mpf_init2
#define _bnc_mpf_random2 mpf_random2
#define _bnc_mpf_set_default_prec mpf_set_default_prec
#define _bnc_mpf_set_prec(x,p) mpf_set_prec(x, p)
#define _bnc_mpf_set_prec_raw mpf_set_prec_raw
#define _bnc_mpf_trunc mpf_trunc
#define _bnc_mpf_sgn mpf_sgn
#define _bnc_mpf_swap mpf_swap

/* functions which take as argument the rounding mode */
#define _bnc_mpf_abs(x,y) mpf_abs(x,y)
#define _bnc_mpf_add(x,y,z) mpf_add(x,y,z)
#define _bnc_mpf_add_ui(x,y,z) mpf_add_ui(x,y,z)
#define _bnc_mpf_div(x,y,z) mpf_div(x,y,z)
#define _bnc_mpf_div_ui(x,y,z) mpf_div_ui(x,y,z)
#define _bnc_mpf_div_2exp(x,y,z) mpf_div_2exp(x,y,z)
#define _bnc_mpf_dump(x,y,z) mpf_dump(x,y,z)
#define _bnc_mpf_get_str(x,y,z,t,u) mpf_get_str(x,y,z,t,u)
#define _bnc_mpf_inp_str(x,y,z) mpf_inp_str(x,y,z)
#define _bnc_mpf_set_str(x,y,z) mpf_set_str(x,y,z)
#define _bnc_mpf_init_set(x,y) mpf_init_set(x,y)
#define _bnc_mpf_init_set_d(x,y) mpf_init_set_d(x,y)
#define _bnc_mpf_init_set_si(x,y) mpf_init_set_si(x,y)
#define _bnc_mpf_init_set_str(x,y,z) mpf_init_set_str(x,y,z)
#define _bnc_mpf_init_set_ui(x,y) mpf_init_set_ui(x,y)
#define _bnc_mpf_mul(x,y,z) mpf_mul(x,y,z)
#define _bnc_mpf_mul_2exp(x,y,z) mpf_mul_2exp(x,y,z)
#define _bnc_mpf_mul_ui(x,y,z) mpf_mul_ui(x,y,z)
#define _bnc_mpf_neg(x,y) mpf_neg(x,y)
#define _bnc_mpf_out_str(x,y,z,t) mpf_out_str(x,y,z,t)
#define _bnc_mpf_pow_ui(x,y,z) mpf_pow_ui(x,y,z)
#define _bnc_mpf_reldiff(x,y,z) mpf_reldiff(x,y,z)
#define _bnc_mpf_set(x,y) mpf_set(x,y)
#define _bnc_mpf_set_d(x,y) mpf_set_d(x,y)
#define _bnc_mpf_set_q(x,y) mpf_set_q(x,y)
#define _bnc_mpf_set_si(x,y) mpf_set_si(x,y)
#define _bnc_mpf_set_ui(x,y) mpf_set_ui(x,y)
#define _bnc_mpf_set_z(x,y) mpf_set_z(x,y)
#define _bnc_mpf_sqrt(x,y) mpf_sqrt(x,y)
#define _bnc_mpf_sqrt_ui(x,y) mpf_sqrt_ui(x,y)
#define _bnc_mpf_sub(x,y,z) mpf_sub(x,y,z)
#define _bnc_mpf_sub_ui(x,y,z) mpf_sub_ui(x,y,z)
#define _bnc_mpf_ui_div(x,y,z) mpf_ui_div(x,y,z)
#define _bnc_mpf_ui_sub(x,y,z) mpf_ui_sub(x,y,z)
#define _bnc_mpf_urandomb(x,y,n) mpf_urandomb(x,y)
